/**
 * Created by robin on 11/1/15.
 */

(function () {
    'use strict';

    angular.module('luticateAuth')
        .factory('luticateAuthCache', ['localStorageService', function (localStorageService) {

            var luticateAuthCache = {};

            luticateAuthCache.setUser = function(user)
            {
                localStorageService.set('lu_user', user);
            };

            luticateAuthCache.getUser = function()
            {
                return localStorageService.get('lu_user');
            };

            luticateAuthCache.getToken = function()
            {
                var user = luticateAuthCache.getUser();
                if (user == null) {
                    return null;
                }
                return user.Token;
            };

            luticateAuthCache.removeUser = function()
            {
                localStorageService.remove('lu_user');
            };

            return luticateAuthCache;
        }]);
})();