/**
 * Created by robin on 11/1/15.
 */

(function () {
    'use strict';
    angular.module('luticateAuth')
        .factory('luticateAuthUsers', ['luticateRequest', '$q', 'luticateAuthCache',
            function(luticateRequest, $q, luticateAuthCache) {

                var luticateAuthUsers = {};

                luticateAuthUsers.login = function(data, promise)
                {
                    var defer = $q.defer();
                    luticateRequest.post("/api/luticate/users/login", data, null, promise)
                        .then(function(data)
                        {
                            luticateAuthCache.setUser(data);
                            defer.resolve(data);
                        }, function(error)
                        {
                            luticateAuthCache.removeUser();
                            defer.reject(error);
                        });
                    return defer.promise;
                };

                luticateAuthUsers.logout = function(promise)
                {
                    var defer = $q.defer();
                    luticateRequest.post("/api/luticate/users/logout", null, null, promise)
                        .then(function(data)
                        {
                            luticateAuthCache.removeUser();
                            defer.resolve(null);
                        }, function(error)
                        {
                            luticateAuthCache.removeUser();
                            defer.resolve(null);
                        });
                    return defer.promise;
                };

                luticateAuthUsers.getAll = function(data, promise)
                {
                    return luticateRequest.get("/api/luticate/users", data, promise);
                };

                luticateAuthUsers.edit = function(data, promise)
                {
                    return luticateRequest.post("/api/luticate/users/" + data.user_id + "/edit", null, data, promise);
                };

            return luticateAuthUsers;
        }]);
})();